from numpy import *

import sys
import os

import Pairwise
import Record


def GetInteraction(M,a,b,Position,L,Ca,Cb,CG,Da,Db,DG,Cntr,Sprd,Rcut2,Ucut,Correction):
    return Pairwise.interaction(a/2,b/2,Rcut2,Ucut,Ca,Cb,Db,Da,transpose(Position),M,Correction,L,CG,DG,Cntr,Sprd)

def GetInteraction0(M,a,b,Position,Ri,i,L,Ca,Cb,CG,Da,Db,DG,Cntr,Sprd,Rcut2,Ucut,Correction):
    return Pairwise.interaction0(a/2,b/2,i,Rcut2,Ucut,Ca,Cb,Db,Da,transpose(Position),Ri,M,Correction,L,CG,DG,Cntr,Sprd)

def Move(d,N,M0,M,a,b,Eta,Position,L,Step,Limit,Bin_Size,Ca,Cb,CG,Da,Db,DG,Cntr,Sprd,Rcut2,Ucut,Correction,U,W,Tmp):
    Accept0 = zeros(M0,int)
    for j in range(N[1]+1):
        i = N[0]-1+int(random.random()*float(N[1]+1))
        Ri = Position[i].copy()
        (Old_U,Old_W) = GetInteraction0(M,a,b,Position,Ri,i,L,Ca,Cb,CG,Da,Db,DG,Cntr,Sprd,Rcut2,Ucut,Correction)
        if (M[i]==0):
            Old_Eta = Eta[int((Ri[0]-Limit[0])/Bin_Size)]
            Ri[0] += (2.*random.random()-1.)*Step[0]
            if ((Ri[0]<=Limit[0])or(Ri[0]>=Limit[1])):
                Ri[0] = Limit[0]-0.5*Bin_Size
            New_Eta = Eta[int((Ri[0]-Limit[0])/Bin_Size)]
        else:
            Old_Eta = 0.
            Ri += (2.*random.rand(d)-1.)*Step[1]
            Ri -= L*round_(Ri/L)
            New_Eta = 0.
        (New_U,New_W) = GetInteraction0(M,a,b,Position,Ri,i,L,Ca,Cb,CG,Da,Db,DG,Cntr,Sprd,Rcut2,Ucut,Correction)
        Exp_ = (Old_Eta-New_Eta)+(Old_U-New_U)/Tmp
        if ((M[i]!=0)or(Ri[0]>Limit[0])):
            if ((Exp_>=0)or(exp(Exp_)>random.random())):
                U += New_U-Old_U
                W += New_W-Old_W
                Position[i] = Ri.copy()
                Accept0[M[i]] += 1
    Accept0 = array([Accept0[0]/float(1),Accept0[1]/float(N[1])],float)
    return (Position,Accept0,U,W)

def SetInteraction(d,N,M0,Kd,a,b,Sigma0,Epsilon0,Rcut0,Ca0,Cb0,CG,Cntr,Sprd,LJ_G,L):
    K_LJ = ((a**(a/(a-b)))/(b**(b/(a-b))))/(a-b)
    Sigma = (Sigma0[:,newaxis]+Sigma0[newaxis,:])*0.5
    Epsilon = (Epsilon0[:,newaxis]*Epsilon0[newaxis,:])**0.5
    (Ca,Cb) = (K_LJ*Epsilon*Sigma**a,K_LJ*Epsilon*Sigma**b)
    if LJ_G:
        (Ca[1][1],Cb[1][1]) = (Ca0,Cb0)
    else:        
        CG = 0.
    (Da,Db)=(Ca*a/float(d),Cb*b/float(d))
    DG = 2.*CG*Sprd/float(d)
    Rcut = Rcut0[0]*Sigma
    Rcut[1][1] = Rcut0[1]*((Ca[1][1]/Cb[1][1])**(1./(a-b)))
    Rcut2 = Rcut*Rcut
    Ucut = Ca/(Rcut**a)-Cb/(Rcut**b)
    Correction = sum(((outer(N,N)*Kd)/(2.*L**d))*(Da/((a-d)*(Rcut**(a-d)))-Db/((b-d)*(Rcut**(b-d)))))
    return (Ca,Cb,CG,Da,Db,DG,Rcut2,Ucut,Correction)

def SetPosition(d,N,N0,M0,M,Sigma0,Bins,Replicate,Dns):
    L = (N[1]/Dns)**(1./d)
    Nd = int((N[1]**(1./d))+0.5)
    L0 = L/Nd
    Step = zeros(M0,float)
    Step += 0.5*L0
    Limit = (0.9*Sigma0[0],0.9*0.5*L)
    Bin_Size = (Limit[1]-Limit[0])/Bins
    Names = []
    for k in M:
        if (k==0):
            Names.append('C')
        else:
            Names.append('O')
    PDB = Record.pdbfile("Movie_%d.pdb"%Replicate,L/Sigma0[0],AtomNames=Names)
    Position = zeros((N0,d),float)
    Position[N[0]-1][0] = L0
    Lattice = L0*arange(Nd)-0.5*(L-L0)
    k = zeros(d,int)
    for i in (range(N[0],N0)):
        for k_d in range(d):
            Position[i][k_d] = Lattice[k[k_d]]
        k_d = 0
        while (k_d<d):
            if (k[k_d]<(Nd-1)):
                k[k_d] += 1
                k_d = d
            else:
                k[k_d] = 0
                k_d += 1
    return (Position,L,Step,Limit,Bin_Size,PDB)

k=0
if (len(sys.argv)>1):
    k = int(sys.argv[1])
if (k<=0):
    k=1
print "HP: ",k    

d = 3  # system dimension
N = (1+k,6**d)  # number of molecules for each species
N0 = sum(N)
M0 = len(N)
M = []
for k in range(M0):
    M.extend([k]*N[k])

Zero = 1./1E6
pi = 3.1415926535897932  # number pi
Kd = 4.*pi  # unit surface
(Boltzmann,Mass) = (1.38065042E-23,2.99150047E-26)  # fundamental parameters

(a,b) = (12,6)  # LJ exponents
Sigma0 = array((3.7300E-10,3.1656E-10),float)  # LJ length scale
Epsilon0 = array((2.0426E-21,1.0796E-21),float)  # LJ energy scale
Rcut0 = (2.5,3.5)

Cycles0 = (10000,100000)
Sample = 200
Bins = 50
Iterations = 5
Replicates = 2
Eta = zeros(Bins,float)

(Tmp0,Dns0) = (280.,1000.)
(Tmp,Dns) = (0.,0.)
#if (len(sys.argv)>2):
    #(Tmp,Dns) = (float(sys.argv[1]),float(sys.argv[2]))
if ((Tmp<=0.)or(Dns<=0.)):
    (Tmp,Dns) = (Tmp0,Dns0)

State_String = "HP_%d"%(N[0]-1)
State_Folder = "%s/"%State_String

Main_Folder = "C:\Programs\HI_SS"
os.chdir(Main_Folder)

Count=0 
if (os.path.isfile("LJ_G.txt")):
    Text = file("LJ_G.txt","r").read()
    Text = Text.split("\n")    
    Data = Text.pop(0).split()
    (Tmp_,Dns_) = (Data.index("Tmp"),Data.index("Dns"))
    ((Ca_,Cb_),(CG_,Cntr_,Sprd_)) = ((Data.index("Ca"),Data.index("Cb")),(Data.index("CG"),Data.index("Cntr"),Data.index("Sprd")))    
    for Line in Text:
        if (Line!=""):
            Data = array(Line.split(),float)
            if ((Data[Tmp_]==Tmp)and(Data[Dns_]==Dns)):
                ((Ca0,Cb0),(CG,Cntr,Sprd)) = ((Data[Ca_],Data[Cb_]),(Data[CG_],Data[Cntr_],Data[Sprd_]))
                Count += 1
if (Count!=1):
    ((Ca0,Cb0),(CG,Cntr,Sprd)) = ((0.,0.),(0.,0.,0.))
    print "Check LJ_G File!"
    Count = 0

if (not os.path.isdir(State_Folder)):
    os.mkdir(State_Folder)
os.chdir(State_Folder)

Tmp = Tmp*Boltzmann
Dns = Dns/Mass

for Replicate in range(Replicates+1):

    print "Replicate: ",Replicate   

    (Position,L,Step,Limit,Bin_Size,PDB) = SetPosition(d,N,N0,M0,M,Sigma0,Bins,Replicate,Dns)
    (Ca,Cb,CG,Da,Db,DG,Rcut2,Ucut,Correction) = SetInteraction(d,N,M0,Kd,a,b,Sigma0,Epsilon0,Rcut0,Ca0,Cb0,CG,Cntr,Sprd,Count,L)    

    Name = "".join("%16s"%k0 for k0 in ("time","U","W","AF_HP","AF_AQ"))
    file("Monitor_%d.txt"%Replicate,"w").write("%s\n\n"%Name)
    Name = "".join("%16s"%k0 for k0 in ("Cycles","Pot1","Pot2","Vir1","Vir2","Step_HP","Step_AQ"))
    file("Values_%d.txt"%Replicate,"w").write("%s\n\n"%Name)
    Name = "".join("%16s"%k0 for k0 in ("R","Eta","Eta_d","Histogram"))
    file("Bins_%d.txt"%Replicate,"w").write("%s\n\n"%Name)    

    for Iteration in range(Iterations+1):

        print "Iteration: ",Iteration    

        for Cycles in Cycles0:

            if ((Replicate==0)and(Iteration==0)):                    
                PDB.write(Position/Sigma0[0])
            (U,W) = GetInteraction(M,a,b,Position,L,Ca,Cb,CG,Da,Db,DG,Cntr,Sprd,Rcut2,Ucut,Correction)
            Line = "".join("%16.4e"%k0 for k0 in (U,W))
            file("Monitor_%d.txt"%Replicate,"a").write("%16d%s\n"%(0,Line))    
    
            Accept = zeros(M0,float)
            (Pot1,Vir1) = (0.,0.)
            (Pot2,Vir2) = (0.,0.)
            Histogram = zeros(Bins,int)
    
            for k in range(Cycles):
        
                (Position,Accept0,U,W) = Move(d,N,M0,M,a,b,Eta,Position,L,Step,Limit,Bin_Size,Ca,Cb,CG,Da,Db,DG,Cntr,Sprd,Rcut2,Ucut,Correction,U,W,Tmp)
            
                Accept = Accept+Accept0
                (Pot1,Vir1) = (Pot1+U,Vir1+W)
                (Pot2,Vir2) = (Pot2+U*U,Vir2+W*W)
                if (Cycles!=Cycles0[0]):  
                    Histogram[int((Position[N[0]-1][0]-Limit[0])/Bin_Size)] += 1

                if (((k+1)%Sample)==0):
            
                    if (Cycles==Cycles0[0]):
                        Step = Step*(Accept/Sample+0.5)
                        Accept = zeros(M0,float)

                    if ((Replicate==0)and(Iteration==0)):                    
                        PDB.write(Position/Sigma0[0])
                        
                    Line = "%s%s"%("".join("%16.4e"%k0 for k0 in (U,W)),"".join("%16.4f"%k0 for k0 in (Accept0[0],Accept0[1])))
                    file("Monitor_%d.txt"%Replicate,"a").write("%16d%s\n"%(k+1,Line))                
                
                    (U0,W0) = GetInteraction(M,a,b,Position,L,Ca,Cb,CG,Da,Db,DG,Cntr,Sprd,Rcut2,Ucut,Correction)
                    if (abs((U-U0)/U0)>Zero):
                        print "Check Pot!",abs((U-U0)/U0)
                    if (abs((W-W0)/W0)>Zero):
                        print "Check Vir!",abs((W-W0)/W0)
                    (U,W) = (U0,W0)

            Accept = Accept/float(Cycles)
            (Pot1,Pot2) = (Pot1/float(Cycles),Pot2/float(Cycles))
            (Vir1,Vir2) = (Vir1/float(Cycles),Vir2/float(Cycles))
            Line = "".join("%16.4e"%k0 for k0 in (Pot1,Pot2,Vir1,Vir2,Step[0],Step[1]))
            file("Values_%d.txt"%Replicate,"a").write("%16d%s\n"%(Cycles,Line))
 
        for k in range(Bins):
            Rk = (Limit[0]+(k+0.5)*Bin_Size)/Sigma0[0]
            Line = "".join("%16.4f"%k0 for k0 in (Rk,-Eta[k]*Tmp/Epsilon0[0],-(Eta[k]+(d-1.)*log(Rk))*Tmp/Epsilon0[0],float(Histogram[k])/sum(Histogram)))
            file("Bins_%d.txt"%Replicate,"a").write("%s\n"%(Line))

        Eta += log(Histogram+1.)
        Eta -= Eta.mean()

        file("Monitor_%d.txt"%Replicate,"a").write("\n")
        file("Values_%d.txt"%Replicate,"a").write("\n")
        file("Bins_%d.txt"%Replicate,"a").write("\n")

    for k in range(Bins):
        Rk = (Limit[0]+(k+0.5)*Bin_Size)/Sigma0[0]
        Line = "".join("%16.4f"%k0 for k0 in (Rk,-Eta[k]*Tmp/Epsilon0[0],-(Eta[k]+(d-1.)*log(Rk))*Tmp/Epsilon0[0]))
        file("Bins_%d.txt"%Replicate,"a").write("%s\n"%(Line))

PDB.close()    